package analysis.gps.client;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import javax.ejb.CreateException;
import java.rmi.RemoteException;
import javax.naming.NamingException;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Hashtable;

import analysis.gps.server.ejb.GPSBroker;
import analysis.gps.server.ejb.GPSBrokerHome;
import analysis.gps.server.ejb.Route;

public class GPSClient extends JFrame implements ActionListener{
	
	final static String EJB_SERVER="jnp://msepc40.sp.cs.cmu.edu:1099";
	//final static String EJB_SERVER="jnp://127.0.0.1:1099";
	static  GPSBroker GPSSystem;
	private JButton Disconnect;
	private JLabel current, next, dest, satellite;
	private JTextField status, nextPosition, currentPosition, destPosition;
	private JPanel c;	
	private String clientID, currentPos, nextPos, destPos;
	private Timer timer= new Timer( ); 
	static int count;
	
	public GPSClient()
	{
		super("GPS  SYSTEM");
		count=0;
		c=(JPanel)this.getContentPane();
		c.setLayout(null);
		c.setBackground(new Color(250, 235, 215));
		status=new JTextField(" ");
		destPosition=new JTextField(" ");
		currentPosition=new JTextField(" ");
		nextPosition=new JTextField(" ");
		Disconnect=new JButton("Disconnect");
		c.add(Disconnect);
		Disconnect.setBounds(new Rectangle(30, 60, 100, 20));
		Disconnect.addActionListener(this);
		
		satellite=new JLabel ("Satellite Status");
		c.add(satellite);
		satellite.setBounds(new Rectangle(30, 280, 250, 20));
		
		current= new JLabel ("Your Current Position");
		c.add(current);
		current.setBounds(new Rectangle(30, 90, 250, 20));
				
		next= new JLabel ("Street-Smart Suggested Next Position");
		c.add(next);
		next.setBounds(new Rectangle(30, 220, 250, 20));
		
		dest= new JLabel ("Your Destination Street");
		c.add(dest);
		dest.setBounds(new Rectangle(30, 155, 250, 20));
		
		
		//Add menu of destination;
		JMenuBar myBar=new JMenuBar();
		setJMenuBar (myBar);		
		
		
		JMenu Destinations=new JMenu("Choose a Destination Street Name");
		JMenuItem item;
		JMenuItem add1 =new JMenuItem("01. CMU at Forbes 5000");
		JMenuItem add2 =new JMenuItem("02. Forbes and Morewood");
		JMenuItem add3 =new JMenuItem("03. Morewood Ave");
		JMenuItem add4 =new JMenuItem("04. Fifth and Morewood");
		JMenuItem add5 =new JMenuItem("05. Fifth and Wilkins");
		JMenuItem add6 =new JMenuItem("06. Fifth Ave");
		JMenuItem add7 =new JMenuItem("07. Fifth and South Aiken");
		JMenuItem add8 =new JMenuItem("08. Fifth and Bellefonte");
		JMenuItem add9 =new JMenuItem("09. Fifth and Ivi");
		JMenuItem add10 =new JMenuItem("10. Forbes and Devon Road");
		JMenuItem add11=new JMenuItem("11. Devon Road");
		JMenuItem add12=new JMenuItem("12. Devon and Warwik");
		JMenuItem add13=new JMenuItem("13. Warwik and Terr");
		JMenuItem add14=new JMenuItem("14. Terr and Wilkins");
		
		add1.addActionListener(this);
		add2.addActionListener(this);
		add3.addActionListener(this);
		add4.addActionListener(this);
		add5.addActionListener(this);
		add6.addActionListener(this);
		add7.addActionListener(this);
		add8.addActionListener(this);
		add9.addActionListener(this);
		add10.addActionListener(this);
		add11.addActionListener(this);
		add12.addActionListener(this);
		add13.addActionListener(this);
		add14.addActionListener(this);
		
		
		Destinations.add(add1);
		Destinations.add(add2);
		Destinations.add(add3);
		Destinations.add(add4);
		Destinations.add(add5);
		Destinations.add(add6);
		Destinations.add(add7);
		Destinations.add(add8);
		Destinations.add(add9);
		Destinations.add(add10);
		Destinations.add(add11);
		Destinations.add(add12);
		Destinations.add(add13);
		Destinations.add(add14);
		
		myBar.add(Destinations);
		setJMenuBar(myBar);
		
		c.add(status);
		status.setBounds(new Rectangle(10, 300, 360, 20));
		status.setEditable(false);
		
		c.add(currentPosition);
		nextPosition.setBounds(new Rectangle(30, 250, 300, 20));
		nextPosition.setEditable(false);
		
		c.add(nextPosition);
		destPosition.setBounds(new Rectangle(30, 185, 300, 20));
		destPosition.setEditable(false);
		
		c.add(destPosition);
		currentPosition.setBounds(new Rectangle(30, 120, 300, 20));
		status.setText("Connection with satellite established! Input destination address.");
		currentPosition.setEditable(false);
		
		setSize(400, 400);
		setLocation(40,10);
		setResizable(true);
		show();
		
	}
	
	public void actionPerformed(ActionEvent e)
	{
		String s=e.getActionCommand(); 
		if (s.equals("Disconnect"))
		{
			try{
				count=0;
				if (clientID!=null){
					GPSSystem.stopService(new Integer(clientID));
				}
				
			}catch(RemoteException ex){
				status.setText(ex.getMessage());
				
				//ex.printStackTrace();
			}
			//System.exit(0);
		}
		else
			try{
				if (0==count){
					//Perform the action of the client;
					String streetNo= s.substring(0,1);
					Integer Num= Integer.valueOf(streetNo);
					
					//Print the destination address;
					destPos=s.substring(3);
					destPosition.setText(destPos);
					status.setText("You are so lucky! The satellite is not down!?");
					
					//The client input the destination address, the server is going to return Route.
					Route instruction= new Route();
					instruction= GPSSystem.getService(Num);
					clientID= instruction.getSessionID();
					currentPos= instruction.getCurrentRoadName();
					nextPos= instruction.getNextRoadName();
					
					currentPosition.setText(currentPos);
					nextPosition.setText(nextPos);
					
					//The client send out the query every five seconds to see where the current position is.
					TimerTask task = new TimerTask() {
						public void run() {
							try{Route nextRoad=GPSSystem.getNextStep(new Integer(clientID));
							currentPosition.setText(nextPos);
							nextPos=nextRoad.getNextRoadName();
							nextPosition.setText(nextPos);
							
							//Check the message from server if the car has arrived the destination.
							//If the client arrive, it will stop the service first, then restart the service.
							if( nextRoad.getServerMessage().equals("You are arrived."))
							{
								currentPosition.setText(destPos);
								JOptionPane.showMessageDialog(null, "You have reached your destination. Thank you for using Street-Smart. Hope you use our services again.",
										"information", JOptionPane.PLAIN_MESSAGE);
								try{
									GPSSystem.stopService(new Integer(clientID));
									nextPosition.setText("");
									currentPosition.setText("");
									destPosition.setText("");
									
								}catch(RemoteException ex){
									status.setText(ex.getMessage());
									//ex.printStackTrace();
								}this.cancel();
								
							}						
							
							}
							catch(RemoteException ex){
								status.setText(ex.getMessage());
								//ex.printStackTrace();
							}
						}
					};
					
					//Set the timer interval;
					timer.schedule(task, 0, 1000);
				}else{					
					JOptionPane.showMessageDialog(null, "You cannot do the next uery till you finish the first one.",
							"Information: No Query", JOptionPane.PLAIN_MESSAGE);	
				}
			
		
	}catch(RemoteException ex){
		
		status.setText(ex.getMessage());
		//ex.printStackTrace();
	}
}
	
	



	public static void main(String[] args) {   		
		
		try {
			//Find the stub and get the interface.
			
			Hashtable props = new Hashtable();

			props.put(
					InitialContext.INITIAL_CONTEXT_FACTORY,
			"org.jnp.interfaces.NamingContextFactory");
			props.put(InitialContext.PROVIDER_URL, EJB_SERVER);

			
			
			InitialContext initial = new InitialContext(props);
			
//			Context initial = new InitialContext();
			Object objref =initial.lookup(analysis.gps.server.ejb.GPSBrokerHome.JNDI_NAME);
			
			GPSBrokerHome home = 
				(GPSBrokerHome)PortableRemoteObject.narrow(objref, 
						GPSBrokerHome.class);
			
			GPSSystem= home.create();       		
			if(GPSSystem!=null)
				System.out.println("Connection set up! ");
			
			//Initialize the client end program.
			JFrame gc=new GPSClient();
			
			//The client decided to exit the program.
			gc.addWindowListener(
					new WindowAdapter()
					{
						public void windowClosing(WindowEvent e)
						{
							System.exit(0);
						}
					}
			);
			
		//Handling of all kinds of these exceptions.	
		}catch(NamingException  ex){
			
			JOptionPane.showMessageDialog(null, "hahaha, Naming exception!",
					"Information: NamingException", JOptionPane.PLAIN_MESSAGE);	
			
		}catch(CreateException ex){
			
			JOptionPane.showMessageDialog(null, "Wah, CreateException!",
					"Information: CreateException", JOptionPane.PLAIN_MESSAGE);
			
		}catch (RemoteException ex) {
			
			System.err.println("Caught an unexpected exception!"+ex.getMessage());			
			JOptionPane.showMessageDialog(null, "Ops! It seemed that I cannot find " +
					"any satellite signal here. Sorry! Try later please. ",
					"Information: RemoteException", JOptionPane.PLAIN_MESSAGE);
			//ex.printStackTrace();
		}
		catch (Exception e){
			System.out.println("EJB Server seems down...");
		}
		
	} 
} 
