/*
 * Created on Feb 14, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package analysis.gps.server.routeFinder;
import javax.ejb.*;
import javax.naming.*;
import java.rmi.*;
import drasys.or.graph.*;
import java.util.*;
import org.apache.log4j.*;
/**
 * @ejb.bean name="CityFactory"
 *	jndi-name="CityFactoryBean"
 *	type="Stateless" 
 * 
 *--
 * This is needed for JOnAS.
 * If you are not using JOnAS you can safely remove the tags below.
 * @jonas.bean ejb-name="CityFactory"
 *	jndi-name="CityFactoryBean"
 * 
 *--
 **/
public abstract class CityFactoryBean implements SessionBean {
	SparseGraph city;
	static Logger logger=Logger.getLogger(CityFactoryBean.class); 
	
	/**
	 * @ejb.interface-method
	 *	view-type="remote" 
	 **/
	public SparseGraph getCity(){
	try{
		if(city==null) buildCity();
		}catch(NamingException e){
			e.printStackTrace();
		}catch(RemoteException e){
			e.printStackTrace();
		}catch(FinderException e){
			e.printStackTrace();
		}catch(DuplicateVertexException e){
			e.printStackTrace();
		}catch(VertexNotFoundException e){
			e.printStackTrace();
		}catch(DuplicateEdgeException e){
			e.printStackTrace();
	}
	return city;
	}
	
	

private void buildCity() throws FinderException,NamingException,RemoteException,DuplicateVertexException,VertexNotFoundException, DuplicateEdgeException{
	HashMap vertices=new HashMap();
	HashMap segments=new HashMap();
	StreetVertex vertex,vertexFrom,vertexTo;
	StreetSegment segment;
	Iterator i;
	Double distance;
	Collection allVertices;
	Collection allSegments;
	StreetVertexHome streetVertexHome;
	StreetSegmentHome streetSegmentHome;
	city=new SparseGraph();
	System.out.println("Building city");
	logger.info("Loading vertices");
	streetVertexHome = (StreetVertexHome)getContext().lookup(StreetVertexHome.JNDI_NAME);
	allVertices=streetVertexHome.findAll();
	i=allVertices.iterator();
	while (i.hasNext()) {
		vertex=(StreetVertex) i.next();
		logger.info("Found vertex:"+vertex.getId()+" x:"+vertex.getX()+" y:"+vertex.getY());			
		vertices.put(vertex.getId(),vertex);
	}

	logger.info("Loading segments");
	streetSegmentHome = (StreetSegmentHome)getContext().lookup(StreetSegmentHome.JNDI_NAME);
	allSegments=streetSegmentHome.findAll();
	i=allSegments.iterator();
	while (i.hasNext()) {
		segment=(StreetSegment) i.next();
		logger.info("Found segment:"+segment.getId()+" from:"+segment.getFromVertexId()+" to:"+segment.getToVertexId());			
		segments.put(segment.getId(),segment);
	}
	
	logger.info("Adding vertices to the city");
	i=allVertices.iterator();
	while(i.hasNext()){
		vertex=(StreetVertex) i.next();
		city.addVertex("("+vertex.getX()+","+vertex.getY()+")",vertex.getId());
	}

	logger.info("Adding segments to the city");
	i=allSegments.iterator();
	while(i.hasNext()){
		segment=(StreetSegment) i.next();
		vertexFrom=(StreetVertex)vertices.get(segment.getFromVertexId());
		vertexTo=(StreetVertex)vertices.get(segment.getToVertexId());
		if((vertexFrom==null)||(vertexTo==null))throw new VertexNotFoundException();
		distance=new Double(Math.sqrt(
				Math.pow((vertexTo.getX().doubleValue()-vertexFrom.getX().doubleValue()),2)
				+
				Math.pow((vertexTo.getY().doubleValue()-vertexFrom.getY().doubleValue()),2)
				));
		logger.info("Adding the segment:"+segment.getId()+","+segment.getStreetName()+
				" from:"+vertexFrom.getId()+" to:"+vertexTo.getId()+". Weight:"+distance);
		city.addEdge("("+vertexFrom.getX()+","+vertexFrom.getY()+")"
				,"("+vertexTo.getX()+","+vertexTo.getY()+")"
				,distance
				,false
				,segment.getStreetName());
		logger.info("City creation finished");
		logger.info("Vertex added:"+city.sizeOfVertices());
		logger.info("Segments added:"+city.sizeOfEdges());
	}
}

private InitialContext getContext() throws NamingException {
	Hashtable props = new Hashtable();

	props.put(
			InitialContext.INITIAL_CONTEXT_FACTORY,
	"org.jnp.interfaces.NamingContextFactory");
	props.put(InitialContext.PROVIDER_URL, "jnp://127.0.0.1:1099");

	// This establishes the security for authorization/authentication
	// props.put(InitialContext.SECURITY_PRINCIPAL,"username");
	// props.put(InitialContext.SECURITY_CREDENTIALS,"password");

	InitialContext initialContext = new InitialContext(props);
	return initialContext;
}
}